"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; desc = parent = undefined; continue _function; } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _searchInput = require("./search-input");

var _searchInput2 = _interopRequireDefault(_searchInput);

var _nestedObjects = require("nested-objects");

var _nestedObjects2 = _interopRequireDefault(_nestedObjects);

/*
 *  @class InfinityMenu
 */

var InfinityMenu = (function (_React$Component) {
	_inherits(InfinityMenu, _React$Component);

	/*
  *  @constructs InfinityMenu
  */

	function InfinityMenu(props) {
		_classCallCheck(this, InfinityMenu);

		_get(Object.getPrototypeOf(InfinityMenu.prototype), "constructor", this).call(this, props);
		this.state = {
			search: {
				isSearching: false,
				searchInput: ""
			}
		};
		this.setSearchInput = this.setSearchInput.bind(this);
		this.stopSearching = this.stopSearching.bind(this);
		this.startSearching = this.startSearching.bind(this);
	}

	/*
  *	@function onNodeClick
  *	@description open or close folder
  *
  *	@param {string} folder - key name of folder object
  */

	_createClass(InfinityMenu, [{
		key: "onNodeClick",
		value: function onNodeClick(tree, node, keyPath, event) {
			event.preventDefault();
			if (!this.state.search.isSearching || !this.state.search.searchInput.length) {
				node.isOpen = !node.isOpen;
				_nestedObjects2["default"].set(tree, keyPath, node);
				if (this.props.onNodeMouseClick) {
					var currLevel = Math.floor(keyPath.split(".").length / 2);
					this.props.onNodeMouseClick(event, tree, node, currLevel, keyPath);
				}
			}
		}

		/*
  * @function shouldComponentUpdate
  * @returns {boolean} return based on user pass in shouldComponentUpdate or return true
  */
	}, {
		key: "shouldComponentUpdate",
		value: function shouldComponentUpdate(nextProps, nextState) {
			if (nextProps.shouldComponentUpdate) {
				return nextProps.shouldComponentUpdate(this.props, this.state, nextProps, nextState);
			} else {
				return true;
			}
		}

		/*
   *	@function startSearching
   *	@description when not searching and search icon clicked, set state to start
   */
	}, {
		key: "startSearching",
		value: function startSearching() {
			this.setState({
				search: {
					isSearching: true,
					searchInput: ""
				}
			});
		}

		/*
   *	@function stopSearching
   *	@description when searching and close icon clicked, set state to stop
   */
	}, {
		key: "stopSearching",
		value: function stopSearching() {
			this.setState({
				search: {
					isSearching: false,
					searchInput: ""
				}
			});
		}

		/*
   *	@function setSearchInput
   *	@description when user types in search input, set phrase in state for filter
   */
	}, {
		key: "setSearchInput",
		value: function setSearchInput(event) {
			this.setState({
				search: {
					isSearching: true,
					searchInput: event.target.value
				}
			});
		}
	}, {
		key: "findFiltered",
		value: function findFiltered(trees, node, key) {
			var _this = this;

			if (!node.children) {
				var nodeMatchesSearchFilter = this.props.filter(node, this.state.search.searchInput);
				if (nodeMatchesSearchFilter) {
					node.isSearchDisplay = true;
					trees[key] = node;
					return trees;
				} else {
					node.isSearchDisplay = false;
					trees[key] = node;
					return trees;
				}
			} else {
				var filteredSubFolder = node.children.length ? node.children.reduce(function (p, c, k) {
					return _this.findFiltered(p, c, k);
				}, []) : [];
				var shouldDisplay = filteredSubFolder.some(function (child) {
					return child.isSearchDisplay;
				});

				if (shouldDisplay) {
					node.isSearchOpen = true;
					node.children = filteredSubFolder;
					node.isSearchDisplay = true;
					trees[key] = node;
					return trees;
				} else {
					node.isSearchOpen = false;
					node.isSearchDisplay = false;
					trees[key] = node;
					return trees;
				}
			}
		}

		/*
   *	@function setDisplayTree
   *	@description recursive go through the tree and set the render tree
   *
   *	@param {array} tree - whole tree
   *	@param {array} prevs - the whole rendering array
   *	@param {object} curr - current node/leaf
   *	@param {string} keyPath - the path to current node/leaf, e.g.  "0.children.1"
   */
	}, {
		key: "setDisplayTree",
		value: function setDisplayTree(tree, prevs, curr, keyPath) {
			var _this2 = this;

			var currLevel = Math.floor(keyPath.length / 2);
			var currCustomComponent = typeof curr.customComponent === 'string' ? this.props.customComponentMappings[curr.customComponent] : curr.customComponent;
			var isSearching = this.state.search.isSearching && this.state.search.searchInput;
			var shouldDisplay = isSearching && curr.isSearchDisplay || !isSearching;
			/*the leaves*/
			if (!curr.children) {
				var itemKey = "infinity-menu-leaf-" + curr.id;
				curr.keyPath = keyPath;
				if (shouldDisplay) {
					if (curr.customComponent) {
						var componentProps = {
							key: itemKey,
							onMouseDown: this.props.onLeafMouseDown,
							onMouseUp: this.props.onLeafMouseUp,
							onClick: this.props.onLeafMouseClick,
							name: curr.name,
							icon: curr.icon,
							data: curr
						};
						prevs.push(_react2["default"].createElement(currCustomComponent, componentProps));
					} else {
						prevs.push(_react2["default"].createElement(
							"li",
							{ key: itemKey,
								className: "infinity-menu-leaf-container",
								onMouseDown: function (e) {
									return _this2.props.onLeafMouseDown ? _this2.props.onLeafMouseDown(e, curr) : null;
								},
								onMouseUp: function (e) {
									return _this2.props.onLeafMouseUp ? _this2.props.onLeafMouseUp(e, curr) : null;
								},
								onClick: function (e) {
									return _this2.props.onLeafMouseClick ? _this2.props.onLeafMouseClick(e, curr) : null;
								}
							},
							_react2["default"].createElement(
								"span",
								null,
								curr.name
							)
						));
					}
				}
				return prevs;
			}
			/*the node*/
			else {
					var key = "infinity-menu-node-" + currLevel + "-" + curr.id;
					var nodeName = curr.name;
					if (!curr.isOpen && !isSearching || !curr.isSearchOpen && isSearching) {
						if (shouldDisplay) {
							if (curr.customComponent) {
								var nodeProps = {
									onClick: this.onNodeClick.bind(this, tree, curr, keyPath),
									name: nodeName,
									isOpen: curr.isOpen,
									isSearching: false,
									data: curr,
									key: key
								};
								prevs.push(_react2["default"].createElement(currCustomComponent, nodeProps));
							} else {
								prevs.push(_react2["default"].createElement(
									"div",
									{ key: key,
										onClick: this.onNodeClick.bind(this, tree, curr, keyPath),
										className: "infinity-menu-node-container"
									},
									_react2["default"].createElement(
										"label",
										null,
										nodeName
									)
								));
							}
						}
						return prevs;
					} else {
						var openedNode = [];
						if (shouldDisplay) {
							if (curr.customComponent) {
								var nodeProps = {
									onClick: this.onNodeClick.bind(this, tree, curr, keyPath),
									name: nodeName,
									isOpen: curr.isOpen,
									data: curr,
									key: key,
									isSearching: isSearching
								};
								openedNode.push(_react2["default"].createElement(currCustomComponent, nodeProps));
							} else {
								openedNode.push(_react2["default"].createElement(
									"div",
									{ key: key,
										onClick: this.onNodeClick.bind(this, tree, curr, keyPath),
										className: "infinity-menu-node-container"
									},
									_react2["default"].createElement(
										"label",
										null,
										nodeName
									)
								));
							}

							var childrenList = curr.children.length ? curr.children.reduce(function (p, c, k) {
								if (c === undefined || k === undefined) {
									return p;
								}
								return _this2.setDisplayTree(tree, p, c, keyPath + ".children." + k);
							}, []) : [];

							if (childrenList.length > 0) {
								openedNode.push(_react2["default"].createElement(
									"ul",
									{ key: "infinity-menu-children-list" + currLevel },
									childrenList
								));
							}
							prevs.push(openedNode);
						}
						return prevs;
					}
				}
		}

		/*
   *  @function _renderBody
   *  @description Renders the body content
   */
	}, {
		key: "renderBody",
		value: function renderBody(displayTree) {
			var _props = this.props;
			var emptyTreeComponent = _props.emptyTreeComponent;
			var emptyTreeComponentProps = _props.emptyTreeComponentProps;

			if (displayTree.length) {
				return displayTree;
			} else if (emptyTreeComponent) {
				var emptyTreeElement = _react2["default"].createElement(emptyTreeComponent, emptyTreeComponentProps);
				return emptyTreeElement;
			} else {
				return null;
			}
		}

		/*
   *  @function render
   *  @description React render method for creating infinity menu
   */
	}, {
		key: "render",
		value: function render() {
			var _this3 = this;

			var tree = this.props.tree;

			/*find filtered folders base on search, if there no search, return all*/
			var filteredTree = this.state.search.isSearching && this.state.search.searchInput ? tree.reduce(function (prev, curr, key) {
				if (key === undefined) {
					return prev;
				}
				return _this3.findFiltered(prev, curr, key);
			}, []) : tree;

			/*recursive go through the tree*/
			var displayTree = filteredTree.reduce(function (prev, curr, key) {
				if (key === undefined) {
					return prev;
				}
				return _this3.setDisplayTree(tree, prev, curr, key.toString());
			}, []);

			/*header component*/
			var headerProps = _extends({
				isSearching: this.state.search.isSearching,
				searchInput: this.state.search.searchInput,
				setSearchInput: this.setSearchInput,
				stopSearching: this.stopSearching,
				startSearching: this.startSearching
			}, this.props.headerProps);

			var bodyContent = this.renderBody(displayTree);
			var defaultHeaderContent = this.props.disableDefaultHeaderContent ? null : _react2["default"].createElement(_searchInput2["default"], headerProps);
			var headerContent = this.props.headerContent ? _react2["default"].createElement(this.props.headerContent, headerProps) : defaultHeaderContent;

			return _react2["default"].createElement(
				"div",
				{ className: "infinity-menu-container" },
				headerContent,
				_react2["default"].createElement(
					"div",
					{ className: "infinity-menu-display-tree-container" },
					bodyContent
				)
			);
		}
	}]);

	return InfinityMenu;
})(_react2["default"].Component);

exports["default"] = InfinityMenu;

InfinityMenu.propTypes = {
	tree: _react2["default"].PropTypes.array,
	headerContent: _react2["default"].PropTypes.any,
	disableDefaultHeaderContent: _react2["default"].PropTypes.bool,
	headerProps: _react2["default"].PropTypes.object,
	customComponentMappings: _react2["default"].PropTypes.object,
	emptyTreeComponent: _react2["default"].PropTypes.any,
	emptyTreeComponentProps: _react2["default"].PropTypes.object,
	filter: _react2["default"].PropTypes.func,
	onNodeMouseClick: _react2["default"].PropTypes.func,
	onLeafMouseClick: _react2["default"].PropTypes.func,
	onLeafMouseDown: _react2["default"].PropTypes.func,
	onLeafMouseUp: _react2["default"].PropTypes.func,
	shouldComponentUpdate: _react2["default"].PropTypes.func
};

InfinityMenu.defaultProps = {
	tree: [],
	headerContent: null,
	disableDefaultHeaderContent: false,
	headerProps: {},
	emptyTreeComponent: null,
	emptyTreeComponentProps: {},
	filter: function filter(node, searchInput) {
		return node.name.toLowerCase().includes(searchInput.toLowerCase());
	},
	onNodeMouseClick: function onNodeMouseClick() {},
	onLeafMouseClick: function onLeafMouseClick() {},
	onLeafMouseDown: function onLeafMouseDown() {},
	onLeafMouseUp: function onLeafMouseUp() {}
};
module.exports = exports["default"];